// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1
//import com.nokia.symbian 1.1
//import Qt.labs.gestures 1.0
import com.nokia.meego 1.0


Page{
    id: detailsViewPage
    property string source
    property string title
    property string owner
    property string date
    property string url
    property variant photo
    property string thumbnail
    property bool inFavorite
    Flickable{
        id: detailsHolder
        anchors.fill: parent
        contentHeight: parent.height + 10
        contentWidth: parent.width
       // anchors.top: detailsViewPage.top
        BorderImage {
            id: placeHolder
            anchors.centerIn: parent
            source: detailsViewPage.thumbnail
            width: parent.width; height: detailsViewPage.height*0.9
            border.left: 5; border.top: 5
            border.right: 5; border.bottom: 5
            visible: mainDetailImage.status == Image.Ready ? false: true
        }
   BorderImage {
        id: mainDetailImage
        source: detailsViewPage.url
        height: detailsViewPage.inFavorite? detailsViewPage.height : detailsViewPage.height*0.9
        width: parent.width
        anchors.centerIn: parent
        border.left: 5; border.top: 5
        border.right: 5; border.bottom: 5
        BusyIndicator{
              running: true             
              anchors.centerIn: parent
              visible: mainDetailImage.status == Image.Ready? false: true
              platformStyle: BusyIndicatorStyle {
                  size: "large"
                  inverted: true
              }
          }
        Rectangle{
            color: "black"
            opacity: 0.7
            height: mainDetailImage.height * 0.2
            anchors.bottom: mainDetailImage.bottom
            width: mainDetailImage.width
            visible: mainDetailImage.status == Image.Ready ? true: false

            Label{
                id: titlelabel
                text: title
                //opacity: 0.4
                anchors.top: parent.top
                 font.bold: true
                platformStyle: LabelStyle {
                         textColor: "white"
                         fontFamily: "Arial"

                     }

            }
            Label{
                id: ownerLabel
                text: "Uploaded by: "+ owner
                //opacity: 0.4
                anchors.top: titlelabel.bottom
                 font.bold: true
                platformStyle: LabelStyle {
                         textColor: "white"
                         fontFamily: "Arial"

                     }

            }
            Label{
                id: sourceLabel
                text: "Source: "+ source
                //opacity: 0.4
                anchors.top: ownerLabel.bottom
                 font.bold: true
                platformStyle: LabelStyle {
                         textColor: "white"
                         fontFamily: "Arial"

                     }

            }
            Label{
                id: dateLabel
                text:detailsViewPage.source == "flickr"? "Uploaded on: " +convertTimeStampToDate(date): "Uploaded on: "+ date
                //opacity: 0.4
                anchors.top: sourceLabel.bottom
                platformStyle: LabelStyle {
                         textColor: "white"
                         fontFamily: "Arial"



                     }
                font.bold: true

            }
        }

        MouseArea{
            anchors.fill: parent
            onClicked: {
                console.log("move")
            }
        }


    }

   Button{
       id: imageOptions
       text: "Add to Favorites"
       //font.pixelSize: 22
       anchors.top: mainDetailImage.bottom
       anchors.topMargin: 1
       anchors.horizontalCenter: parent.horizontalCenter
       width: parent.width * 0.75
      // height: 40
       onClicked: savePhoto(photo)
       visible: !detailsViewPage.inFavorite && (mainDetailImage.status == Image.Ready)// This is available in all editors.
       platformStyle: ButtonStyle{
           inverted: true
       }
   }

    }
   ScrollDecorator {
        id: detailsHolderScroll
        flickableItem: detailsHolder
        anchors { right: detailsViewPage.right; bottom: detailsViewPage.bottom }
    }

}
