// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1
//import com.nokia.symbian 1.1
import com.nokia.meego 1.0

Page{
    id: favorites
    onActiveFocusChanged: loadFavorites()
    Label{
        text: "You have not saved any photos yet"
        anchors.centerIn: parent
        visible: favoritesModel.count < 1? true : false
    }

    GridView{
        id: photoGrid
        cellWidth: parent.width / 4
        cellHeight: cellWidth
        anchors.fill: parent
        anchors.topMargin: pageToolbar.height
        anchors.centerIn: parent
        model: favoritesModel
        delegate: Component{
            Item {
                id: wrapper
            height: photoGrid.cellHeight
            width: photoGrid.cellWidth
            BorderImage {
                id: photoThumb
                width: parent.width - 5
                height: parent.height - 3
                border.left: 5; border.top: 5
                border.right: 5; border.bottom: 5
                smooth: true
                source: photo.thumbnail
                MouseArea{
                    anchors.fill: parent
                    onClicked: {
                        var url = photo.url
                        var title = photo.title
                        var source = photo.source
                        var owner = photo.owner
                        var date = photo.upload_date
                        var thumbnail = photo.thumbnail
                        console.log(source)
                        window.pageStack.push(photoDetails, {"source": source,
                                                  "title": title,
                                                  "url": url,
                                                  "owner": owner,
                                                  "date": date,
                                                  "photo": photo,
                                                  "thumbnail":thumbnail,
                                                  "inFavorite": true
                                              })
                    }
                    onPressAndHold: photoContextmenu.open()
                }
        }

          BusyIndicator{
                running: true
                height: 20
                width: 20
                anchors.centerIn: parent
                visible: photoThumb.status == Image.Ready? false: true
            }



        }
        }
        }

  ScrollDecorator {
        id: photoGridScroll
        flickableItem: photoGrid
        anchors { right: photoGrid.right; bottom: photoGrid.bottom }
    }
}
