import QtQuick 1.1
//import com.nokia.symbian 1.1
import com.nokia.meego 1.0
import QtMobility.location 1.2

Page {
    id: listViewpage
    Flickable{
        id: listViewFlick
        anchors.fill: parent
        contentHeight: parent.height
        contentWidth: parent.width
    ListView{
        id: photoListView
        anchors.fill: parent
        model: photoModel
        delegate: Rectangle{
            id: photoListItem
            height: 125
            width: parent.width
            anchors.topMargin: 5
            color: index%2 ? "#f6f6f6" : "white"
            Row{
                anchors.fill: photoListItem.padding
                anchors.verticalCenter: parent.verticalCenter
                Image {
                    id: photoListThumb
                    source: photo.thumbnail
                    height: 120
                    width: 120
                    anchors.verticalCenter: parent.verticalCenter
                    Rectangle{
                        anchors.fill: photoListThumb
                        color: "transparent"
                        border.color: index%2 ? "#f6f6f6" : "white"
                        radius: 5
                        border.width: 4
                    }
                  BusyIndicator{
                        running: true
                        height: 20
                        width: 20
                        anchors.centerIn: parent
                        visible: photoListThumb.status == Image.Ready? false: true
                    }
                }
                Column{
                    id: listItemColumn
                    anchors.verticalCenter: parent.verticalCenter

                    Text{
                        text: sliceText(photo.title, 50)
                        //mode: photoListItem.mode
                        font.bold: true
                        font.pixelSize: 25
                        anchors.leftMargin: 5
                        width: listViewpage.width - 120
                        wrapMode: Text.WordWrap

                    }
                    Text{
                        text: sliceText(photo.owner, 30)
                       // mode: photoListItem.mode
                        font.pixelSize: 20
                        anchors.leftMargin: 5
                        width: listViewpage.width - 120
                        wrapMode: Text.WordWrap
                       // anchors.bottom: parent.bottom
                    }
                }
            }
            MouseArea{
                anchors.fill: parent
            onClicked: {
                var url = photo.url
                var title = photo.title
                var source = photo.source
                var owner = photo.owner
                var date = photo.upload_date
                var thumbnail = photo.thumbnail
                console.log(source)
                window.pageStack.push(photoDetails, {"source": source,
                                          "title": title,
                                          "url": url,
                                          "owner": owner,
                                          "date": date,
                                          "photo": photo,
                                          "thumbnail": thumbnail,
                                          "inFavorite": false
                                      })
            }
        }


        }

    }
    }

   ScrollDecorator{
        id: listViewScroll
        flickableItem: listViewFlick
        anchors { right: listViewFlick.right; bottom: listViewFlick.bottom }
    }
}
