import QtQuick 1.1
//import com.nokia.symbian 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.1
import QtMobility.location 1.2

// nairobi lt Coordinates (Lat/Lng): -1.37, 36.85 -1.253988056295949, 36.83249115943909

Page {
    id: mainPage
    signal search
    signal satellite
    signal hybrid
    signal street
    signal panMap(double newlat, double newlng)
    signal move
   // property list <MapImage> markers
    property variant markers: []




    Rectangle {
       id: pinchmap
       property double defaultLatitude: 37.69
       property double defaultLongitude: -97.33
       property int  defaultZoomLevel: (myPositionSource.position.coordinate.latitude || window.locationFoundViaGeocode) ? 14 : 1
       property alias mapType: map.mapType
       //anchors.fill: parent
       width: parent.width
       height: parent.height
       Map {
          id: map
          //anchors.fill: parent
          height: parent.height
          width: parent.width
          zoomLevel: pinchmap.defaultZoomLevel
          plugin: Plugin { name: "nokia" }
          mapType: Map.StreetMap
         // mapType: Map.HybridMode
         // mapType: Map.SatelliteMapDay

          /*MapObjectView {
               id: photoMapView
               model: photolandmarkModel
               delegate: Component {
                   MapImage {
                      id: mapThumbnail
                      width: 30
                      height: 30
                     // source: photo.thumbnail
                      source: "images/Icon.png"
                      coordinate: Coordinate{
                          //latitude: photo.coordinate.latitude
                          latitude: window.currentCenterLat
                          //longitude: photo.coordinate.longitude
                          longitude: window.currentCenterLng
                      }
                    }
               }
           }*/

          center: Coordinate {
            // latitude: pinchmap.defaultLatitude
             //longitude: pinchmap.defaultLongitude
              latitude: currentPos.latitude ? currentPos.latitude : 0.1
              longitude: currentPos.longitude ? currentPos.longitude : 0.1
              //latitude: window.currentCenterLat
              //longitude: window.currentCenterLng
          }
          onCenterChanged: {
              window.currentCenterLat = map.center.latitude
              window.currentCenterLng = map.center.longitude
          }
          Component.onCompleted: {
              window.topLeft = map.toCoordinate(Qt.point(map.height, 0))
              window.bottomRight = map.toCoordinate(Qt.point(0,map.width))
              map.addMapObject(mapRectangle)
          }


       }

       PinchArea {
          id: pincharea

          property double __oldZoom

          anchors.fill: parent

          function calcZoomDelta(zoom, percent) {
             return zoom + Math.log(percent)/Math.log(2)
          }

          onPinchStarted: {
             __oldZoom = map.zoomLevel
              consol.log(map.zoomLevel)
          }

          onPinchUpdated: {
             map.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
              console.log(map.zoomLevel)
          }

          onPinchFinished: {
             map.zoomLevel = calcZoomDelta(__oldZoom, pinch.scale)
              console.log(map.zoomLevel)
          }
       }

       MouseArea {
          id: mousearea

          property bool __isPanning: false
          property int __lastX: -1
          property int __lastY: -1

          anchors.fill : parent

          onPressed: {
             __isPanning = true
             __lastX = mouse.x
             __lastY = mouse.y
          }

          onReleased: {
             __isPanning = false
          }

          onPositionChanged: {
             if (__isPanning) {
                var dx = mouse.x - __lastX
                var dy = mouse.y - __lastY
                map.pan(-dx, -dy)
                __lastX = mouse.x
                __lastY = mouse.y
                 window.currentMouseX = mouse.x
                 window.currentMouseY = mouse.y
             }
            // console.log(mouse.x +", "+ mouse.y)
            // console.log(map.center.latitude +", "+map.center.longitude)
             console.log(window.currentCenterLat +", "+ window.currentCenterLng)
             console.log(window.currentMouseX +", "+ window.currentMouseX)
             var co = map.toCoordinate(Qt.point(map.width,map.height)) // topRight
             window.topLeft = map.toCoordinate(Qt.point(0, 0))
             window.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
             mainBoundingBox.topLeft = map.toCoordinate(Qt.point(0,0))
             mainBoundingBox.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
            mapRectangle.bottomRight = map.toCoordinate(Qt.point(map.width, 0))
             mapRectangle.topLeft = map.toCoordinate(Qt.point(10, 10))

           //  window.topLeft = map.toCoordinate(Qt.point(0,map.height)) //topLeft
            // window.bottomRight = map.toCoordinate(Qt.point(map.width, 0)) //bottomright
           //  var co3 = map.toCoordinate(Qt.point(map.height, 0))
            // console.log(co.latitude +" map width, "+co.longitude+" map height")
            // console.log(co1.latitude +" map width, "+co1.longitude+" map height")
            // console.log(co2.latitude +" map width, "+co2.longitude+" map height")
            // console.log(co3.latitude +" map width, "+co3.longitude+" map height")
             console.log(window.topLeft.latitude+" topLeft latitude "+ window.topLeft.longitude +" topleft Longitude")
             console.log(window.bottomRight.latitude+" bottomRight latitude "+ window.bottomRight.longitude +" bottomRight Longitude")
             console.log(mainBoundingBox.center.latitude+", "+ mainBoundingBox.center.longitude +" boundingbox center")
             console.log(map.center.latitude +", "+map.center.longitude +" map.center")
             console.log(mainBoundingBox.topLeft.latitude +" bounding box topleft latitude")
             console.log(mainBoundingBox.topLeft.longitude +" bounding box topleft Longitude")
             console.log(mainBoundingBox.bottomRight.latitude +" bounding box BottomRight latitude")
             console.log(mainBoundingBox.bottomRight.longitude +" bounding box bottomright longitude")


             console.log(mapRectangle.height +" map rectangle height")
             console.log(mapRectangle.bottomRight.latitude +" map rectangle bottom right latitude")
             console.log(mapRectangle.bottomRight.longitude +" map rectangle bottom right longitude")
             console.log(mapRectangle.topLeft.latitude +" map rectangle top left latitude")
             console.log(mapRectangle.topLeft.longitude + " map rectangle top left longitude")
             //dumpBoundingBox()

             //searchPanoramio()

              //map.addMapObject(mapCircle)


          }

          onCanceled: {
             __isPanning = false;
          }
       }
       Label{
           text: "visibility"
           color: "red"
           anchors.top: parent.top
       }
       Item{
           height: 70
           width: parent.width
           anchors.bottom: parent.bottom           
           Column{
          Label{
               id: latlabel
               color: "black"
               text: "Latitude: " + window.currentCenterLat
               anchors.top: parent.top
               font.bold: true
           }
           Label{
               id: lnglabel
               color: "black"
               text: "Longitude: " + window.currentCenterLng
               anchors.top: latlabel.bottom
               font.bold: true
           }
           visible: ((!mapObjectProgress.visible) && (pinchmap.height == mainPage.height)) && (window.currentCenterLat && window.currentCenterLng) && (!viewAll.visible)&& (!window.locationFoundViaGeocode) && myPositionSource.position.coordinate.latitude
          // visible: false
       }
           Label{
               id: humanReadableAddress
               anchors.centerIn: parent
               visible: window.locationFoundViaGeocode
               text: window.userLocation
               color: "black"
               font.bold: true
           }
           ProgressBar{
               id: mapObjectProgress
               minimumValue: 0
               maximumValue: window.photosfound
               value: window.mapObjectsCreated
               anchors.bottom: parent.bottom
               anchors.bottomMargin:  10
               width: parent.width -10
               //height: 20
               anchors.horizontalCenter: parent.horizontalCenter
               visible: (window.photosfound > 0) && !(window.mapObjectsCreated == window.photosfound)
           }


       }
    //   Item{
     //      anchors.centerIn: parent
         //  anchors.horizontalCenterOffset: -50
           //
           Rectangle{
               anchors.centerIn: parent
               opacity: 0.7
               width: parent.width * 0.8
               height: width / 4
               radius: 5
               color: "black"
                visible: !myPositionSource.position.coordinate.latitude && !window.locationFoundViaGeocode
               Row{
                   spacing: 35
                   anchors.centerIn: parent
               BusyIndicator{
                running: true
                platformStyle: BusyIndicatorStyle {
                    size: "medium"
                    inverted: true
                }
               }
               Text {
                   text: qsTr( "Loading GPS Info....")
                   anchors.centerIn: parent
                   color: "white"
                   font.bold: true
                   font.pixelSize: 20
               }
               }
               gradient: Gradient {
                   GradientStop { position: 0.0; color: "#5c5c5c" }
                   GradientStop { position: 0.5; color: "#161616" }
               }


           }


   // }
       Button{
           id: viewAll
           text: "View All"
           anchors.bottom: parent.bottom
          // platformInverted: false
           anchors.horizontalCenter: parent.horizontalCenter
           width: parent.width * 0.65
           font.pixelSize: 22
           visible: (window.flickrSearched && window.panoramioSearched) && (window.photosfound - window.mapObjectsCreated  < 20) &&(window.photosfound)
           onClicked: window.pageStack.push(photogrid)
           opacity: 0.85
           platformStyle: ButtonStyle{
               inverted: true
           }

       }
       Rectangle{
           anchors.centerIn: parent
           opacity: 0.7
           visible: window.loading || (window.mapObjectsCreated < window.photosfound)
           width: parent.width * 0.8
           height: width / 4
           radius: 5
           Text {
               text: qsTr( "Searching Map For Photos.....")
               anchors.centerIn: parent
               color: "white"
               font.bold: true
               font.pixelSize: 20
           }
           gradient: Gradient {
               GradientStop { position: 0.0; color: "#5c5c5c" }
               GradientStop { position: 0.5; color: "#161616" }
           }


       }

    }

    Component.onCompleted: {
        //console.log(map.toCoordinate(Qt.point(map.width,map.height)))
        var co = map.toCoordinate(Qt.point(map.width,map.height))
        //console.log(co.latitude +" "+co.longitude)
       // console.log(map.width)

      //  console.log(map.center.latitude)
        mainBoundingBox.topLeft = map.toCoordinate(Qt.point(0,0))
        mainBoundingBox.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
    }

    BoundingBox{
        id: mainBoundingBox
        topLeft: Coordinate{
           // latitude: window.topLeft.latitude
            latitude: 90
            longitude: 180
            //longitude: window.topLeft.longitude
        }
        //topLeft: map.toCoordinate(Qt.point(0,0))
        //bottomRight: map.toCoordinate(Qt.point(map.width, map.height))


        bottomRight: Coordinate{
               latitude: -90
               longitude: -180
            }
        height: window.height
        width: window.width
        Component.onCompleted: {
            console.log(mainBoundingBox.height +" bounding box height")

        }
    //    -1.1431190862298992 topLeft latitude 36.96707367897034 topleft Longitude
     //   -1.266687925000969 bottomRight latitude 36.76794648170471 bottomRight Longitude
    }
    MapImage{
        id: mapImage
        //width: 10
       // height: 10
        source: "http://mw2.google.com/mw-panoramio/photos/medium/255842.jpg"
        coordinate: Coordinate{
            latitude:-1.253988
            longitude: 36.832491
        }
        Component.onCompleted: {
            //map.addMapObject(mapImage)
        }
    }
    MapRectangle{
        id: mapRectangle
        color: "black"
        bottomRight: map.toCoordinate(Qt.point(map.width, 0))
        topLeft: map.toCoordinate(Qt.point(0, 1))
       // topLeft: map.toCoordinate(Qt.point(0,0))
        //bottomRight: map.toCoordinate(Qt.point(0,0))
        /*bottomRight: Coordinate{
            latitude: mainBoundingBox.bottomRight.latitude
            longitude: mainBoundingBox.bottomLeft.longitude
        }*/
        //topLeft: map.toCoordinate(Qt.point(1.5,1.5))
       /* topLeft: Coordinate {
            latitude: mainBoundingBox.topLeft.latitude
            longitude: mainBoundingBox.topRight.longitude

        }*/
        Component.onCompleted: {
            console.log(mapRectangle.height +" map rectangle height")
            console.log(mapRectangle.bottomRight.latitude +" map rectangle bottom right latitude")
            console.log(mapRectangle.bottomRight.longitude +" map rectangle bottom right longitude")
            console.log(mapRectangle.topLeft.latitude +" map rectangle top left latitude")
            console.log(mapRectangle.topLeft.longitude + " map rectangle top left longitude")
            map.addMapObject(mapRectangle)
        }
    }

    Item{
        id: notificationArea
        width: parent.width
        height: 40
        anchors.top: pinchmap.bottom
        Button{
            text: "View All"
            anchors.centerIn: parent
            width: parent.width / 1.5
            height: parent.height * 0.8
            onClicked: window.pageStack.push(photogrid)
            platformStyle: ButtonStyle{
                inverted: true
            }
        }
    }
    states: [
        State {
            name: "mapSlideUp"
            PropertyChanges {target: pinchmap; height: parent.height - notificationArea.height}
            ///when: 1 < photoModel.count && photoModel.count < 100
            //when: (window.mapObjectsCreated) && (window.mapObjectsCreated == window.photosfound)
            //when: (window.flickrSearched && window.panoramioSearched) && (window.mapObjectsCreated == window.photosfound)
        }
    ]
    transitions: [
        Transition {
            from: "*"; to:"mapSlideUp"
            PropertyAnimation {target: pinchmap; property: "height"; duration: 500; }
            },
        Transition {
            from: "mapSlideUp"; to:"*"
            PropertyAnimation {target: pinchmap; property: "height"; duration: 500; }
            }
    ]


    function searchPanoramio(){
        mainBoundingBox.topLeft = map.toCoordinate(Qt.point(0,0))
        mainBoundingBox.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
    var minx = mainBoundingBox.topLeft.longitude
    var miny = mainBoundingBox.bottomRight.latitude
    var maxx = mainBoundingBox.bottomRight.longitude
    var maxy = mainBoundingBox.topLeft.latitude
    var url = "http://www.panoramio.com/map/get_panoramas.php?set=public&from=0&to=50&minx="+minx+"&miny="+miny+"&maxx="+maxx+"&maxy="+maxy+"0&size=medium&mapfilter=true";
        console.log(url)
        var json = new XMLHttpRequest();
        //json.setRequestHeader("Content-Type", "text/plain;charset=UTF-8")
        json.onreadystatechange = function(){
        if(json.readyState == XMLHttpRequest.DONE){
           // if(json.readyState == 4){container.state = "homescreen"}
            try{
           var data = JSON.parse(json.responseText)
           // var data = eval('(' + json.responseText + ')');
            }
            catch(e){
                //notifyUser("No "+ name +" found nearby")
                console.log(json.responseText)
            }
            //var l = data.length
            var photos = data['photos']
            if(photos){
               // var l = photos.length
                var l = photos.length > 50? 50 : photos.length
                var tmp  = window.photosfound
                var newphotos = tmp + l
                window.photosfound = newphotos
                window.panoramioSearched = true
                console.log(window.photosfound + "photos found after panoramio")
                for(var x=0; x<l; x++){
                    var photo = {
                        "title": photos[x]['photo_title'],
                        "url": photos[x]['photo_file_url'],
                        "coordinate": {
                            "latitude": photos[x]['latitude'],
                            "longitude":  photos[x]['longitude']
                        },
                        "source": "Panoramio",
                        "thumbnail": photos[x]['photo_file_url'],
                        "upload_date": photos[x]['upload_date'],
                        "owner": photos[x]['owner_name'],
                        "photo_id": this.source +"_"+ photos[x]['photo_id']

                    }
                    createMapObject(photo)
                    photoModel.append({"photo": photo})                  

                    //console.log(photo)
                }
                window.loading = false



            }
            else{
        //data fetch failed
                console.log("data fetch failed")
               // console.log(json.responseText)

        }
        }
        else{
            console.log(json.readyState)
                //hide loading
            //container.state = "homescreen"

                }
        }
        json.open("GET", url)
        json.send()
        //container.state = "loading"
       // resultsModel.clear()
        window.loading = true
        //photoModel.clear()
    }
    function searchFlickr(){
    /*
      we first construct the bbox parameter in this format "&bbox=36.770%2C+-1.3545%2C+36.893%2C+-1.155"
      &bbox=36.77%2C+-1.3545%2C+36.893%2C+-1.155
      part1 of url =  "http://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=74a254a34e970d0871c8d5f61801d0c5&min_upload_date=1267250400&privacy_filter=1"
      part 3 = "&safe_search=1&has_geo=1&per_page=50&page=1&format=json&nojsoncallback=1"
      url =  part1+bbox+part3


      console.log (url)
      */
        mainBoundingBox.topLeft = map.toCoordinate(Qt.point(0,0))
        mainBoundingBox.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
        var minLng = mainBoundingBox.topLeft.longitude
        var minLat = mainBoundingBox.bottomRight.latitude
        var maxLng = mainBoundingBox.bottomRight.longitude
        var maxLat = mainBoundingBox.topLeft.latitude
        var part1 = "http://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=74a254a34e970d0871c8d5f61801d0c5&min_upload_date=1267250400&privacy_filter=1"
        var bbox = "&bbox="+minLng+"%2C+"+minLat+"%2C+"+maxLng+"%2C+"+maxLat
        var part3 = "&safe_search=1&has_geo=1&per_page=50&page=1&format=json&nojsoncallback=1"
        var url = part1+bbox+part3
        console.log(url)
        var json = new XMLHttpRequest();
        //json.setRequestHeader("Content-Type", "text/plain;charset=UTF-8")
        json.onreadystatechange = function(){
        if(json.readyState == XMLHttpRequest.DONE){
            try{
           var data = JSON.parse(json.responseText)
            }
            catch(e){

                console.log(json.responseText)
            }
            var photos = data['photos']['photo']
            if(photos){
                var l = photos.length > 50? 50 : photos.length
                var tmp  = window.photosfound
                var newphotos = tmp + l
                window.photosfound = newphotos
                window.flickrSearched = true
                console.log(window.photosfound +" photos found after flickr search")
                for(var x=0; x<l; x++){
                    var photoId = photos[x]['id']
                    getFlickrPhoto(photoId)

                    //console.log(photo)
                }

                    searchPanoramio()




            }
            else{
        //data fetch failed
                console.log("data fetch failed")
               // console.log(json.responseText)

        }
        }
        else{
            console.log(json.readyState)
                //hide loading
            //container.state = "homescreen"

                }
        }
        json.open("GET", url)
        json.send()
        //container.state = "loading"
       // resultsModel.clear()
        window.loading = true



    }
    function getFlickrPhoto(id){
        var part1 = "http://api.flickr.com/services/rest/?method=flickr.photos.getInfo&api_key=74a254a34e970d0871c8d5f61801d0c5&format=json&nojsoncallback=1"
        var part2 = "&photo_id="+id
        var url = part1+part2
        //return url
        var json = new XMLHttpRequest();
        //json.setRequestHeader("Content-Type", "text/plain;charset=UTF-8")
        json.onreadystatechange = function(){
        if(json.readyState == XMLHttpRequest.DONE){
            try{
           var data = JSON.parse(json.responseText)
               // console.log(data)
            }
            catch(e){

                console.log(json.responseText)
            }

            var status = data['stat']
            if(status === 'ok'){
                console.log("status is ok")
                var details = data['photo']
                var secret = details['secret']
                var farm = details['farm']
                var server = details['server']
                var id = details['id']
                var photo = {
                    "title": details['title']['_content'],
                    "url": "http://farm"+farm+".staticflickr.com/"+server+"/"+id+"_"+secret+"_z.jpg",
                    "coordinate": {
                        "latitude": details['location']['latitude'],
                        "longitude": details['location']['longitude']
                    },
                    "source": "flickr",
                    //"thumbnail": "http://farm"+farm+".staticflickr.com/"+server+"/"+id+"_"+secret+"_t.jpg",
                    "thumbnail": "http://farm"+farm+".staticflickr.com/"+server+"/"+id+"_"+secret+"_s.jpg",
                    "upload_date": details['dates']['posted'],
                    "owner": details['owner']['username'],
                    "photo_id": this.source +"_"+ id
                }
                 photoModel.append({"photo": photo})
                 createMapObject(photo)

                }
            window.loading = false

        }

        }
        json.open("GET", url)
        json.send()
        window.loading = true
//return photo
    }
    function createMapObject(photo){
        //map.addMapObject(photoMapView)
        var lat = photo.coordinate.latitude
        var lng = photo.coordinate.longitude
        var title = photo.title
        var url = photo.thumbnail
        console.log(url)
        var component = Qt.createComponent("PushImage.qml");
        console.log(component.status + " " + Component.Null);
        var object = component.createObject(mainPage, {
                                                "lat": lat,
                                                "lng": lng,
                                               "thumbnail":url,
                                                "title": title
                                            }
                                                           );
        if (object.status == Component.Ready) {
             console.log("Component ready");
             map.addMapObject(object)
            object.clicked.connect(mapPhotoClicked)
            var tmp = mainPage.markers
            tmp.push(object)
            mainPage.markers = tmp
            var tmp2 = window.mapObjectsCreated
            tmp2 ++
            window.mapObjectsCreated = tmp2
            console.log(window.mapObjectsCreated +" map objects created")
            window.loading = false
            //console.log(map.markers.length)

        }
        window.loading = true
    }
    function mapPhotoClicked(){
        console.log("click")
        //window.pageStack.push(photoDetails)
    }
    function setMapToType(type){
        switch(type){
        case "satellite":
            map.mapType = Map.SatelliteMapNight
            break;
        case "street":
            map.mapType = Map.StreetMap
            break;
        case "hybrid":
           // map.mapType = Map.HybridMode
            map.mapType = Map.TerrainMap
            break;
        }
    }
    function searchPhotos(){
        removeMapObjects()
        window.pageStack.pop(null)
        window.loading = true
        photoModel.clear()        
        searchFlickr()
        //mybanner.open()
        window.flickrSearched = false
        window.panoramioSearched = false

    }
    function removeMapObjects(){
        console.log("clear all markers men!!!!")
        var tmp = mainPage.markers
        var l = tmp.length
        console.log(l)
        if(l){
        for(var x=0; x<l; x++){
            map.removeMapObject(tmp[x])
            console.log(x+" removed")
        }
        mainPage.markers = []
        window.mapObjectsCreated = 0
        window.photosfound = 0
        }
    }
    function panMyMap(lat, lng){
        //mainBoundingBox.topLeft = map.toCoordinate(Qt.point(0,0))
       // mainBoundingBox.bottomRight = map.toCoordinate(Qt.point(map.width, map.height))
        if(lat && lng){
        map.center.latitude = lat
       map.center.longitude = lng
            if(window.pageStack.depth >= 1){
                 window.pageStack.pop(null)
            }
        }

    }



}
